package com.iden.bms.service;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.iden.common.entity.IdenFaceImage;
import com.iden.common.entity.IdenWarningEvent;
import com.iden.common.entity.IdenWarningPerson;
import com.iden.common.entity.IdenWarningPersonTrace;
import com.iden.common.enums.HandleWarningStatusEnum;
import com.iden.common.exception.BDException;
import com.iden.common.service.*;

import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;


import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author makejava
 * @since 2021-05-21 00:08:38
 */
@Service
public class WarningService {

    @Resource
    private IdenFaceImageService idenFaceImageService;
    @Resource
    private IdenWarningEventService idenWarningEventService;
    @Resource
    private IdenWarningPersonService idenWarningPersonService;
    @Resource
    private IdenWarningPersonTraceService idenWarningPersonTraceService;
    @Resource
    private IdenWarningStaService idenWarningStaService;

    /**
     * 处理预警
     * @return
     */
    public void handleWarning() throws BDException {
      //查询没有处理过的人脸图像数据
        QueryWrapper<IdenFaceImage> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(IdenFaceImage::getHandleWarningStatus, HandleWarningStatusEnum.NO_HANDLE.getValue())
        .last("limit 5000"); //每次处理5000条
        List<IdenFaceImage> idenFaceImageList = idenFaceImageService.list(queryWrapper);
        if (CollUtil.isEmpty(idenFaceImageList)) {
            return;
        }

        for (IdenFaceImage idenFaceImage : idenFaceImageList) {
            //去除同一个摄像头下2分钟内同一个人的人脸图像
            if(true){
               continue;
            }
            //重点人员识别预警
            String type = idenFaceImage.getType();
            if (StringUtils.isNotEmpty(type) && type.indexOf("1") != -1) {
                IdenWarningPerson idenWarningPerson = new IdenWarningPerson();

                this.idenWarningPersonService.save(idenWarningPerson);

                IdenWarningEvent idenWarningEvent = new IdenWarningEvent();
                idenWarningEvent.setWarningPersonId(idenWarningPerson.getId());
                this.idenWarningEventService.save(idenWarningEvent);

                IdenWarningPersonTrace idenWarningPersonTrace = new IdenWarningPersonTrace();
                BeanUtil.copyProperties(idenFaceImage,idenWarningPersonTrace);
                idenWarningPersonTrace.setId(null);
                idenWarningPersonTrace.setWarningPersonId(idenWarningPerson.getId());
                this.idenWarningPersonTraceService.save(idenWarningPersonTrace);

            }
        }

    }


}